/*  LightAppDlg.cpp -- main dialog service functions implementation   
 
    This is part of LightApp, demostration software agent using SecureFW protective interface.
    See http://www.svenda.com/petr/dpthesis/index.html for more information
    Copyright (C) 2004  Petr Svenda <petr@svenda.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Please, report any bugs to author <petr@svenda.com>
/**/


#include "stdafx.h"
#include "LightApp.h"
#include "LightAppDlg.h"
#include "CommonFnc.h"
#include "..\SecureFW\SecFunctProvider.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BYTE adminPassword[16] = {0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x11, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22, 0x22};

const unsigned char UUID_ALGORITHM[16] = {0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55};

CLightAppDlg*   pLightApp = NULL;
/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLightAppDlg dialog

CLightAppDlg::CLightAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLightAppDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLightAppDlg)
	m_activeHWT = FALSE;
	m_authSWA = FALSE;
	m_actualOperation = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_AID = AID;
    m_UUIDHWT = UUIDHWT;
    pLightApp = this;


/*
    TEST:
    int         status = STAT_OK;
    BYTE        buff1[1000];
    BYTE        buff2[1000];
    BYTE        rawKey[KEY_LENGTH];
    BYTE        iv[BLOCK_LENGTH];
    DWORD       buff1Len = 1000;
    DWORD       buff2Len = 1000;
    DWORD       maxBuff1Len = 1000;

    memset(buff1, 0, buff1Len);
    memset(buff2, 0, buff2Len);

    memset(rawKey, 3, KEY_LENGTH);
    memset(iv, 4, KEY_LENGTH);

    strcpy((char*) buff1, (LPCTSTR) m_UUIDHWT);
    strcpy((char*) buff2, (LPCTSTR) m_UUIDHWT);

    buff1Len = m_UUIDHWT.GetLength();

    status = CSecFunctProvider::AES128_EncryptCBC(buff1, &buff1Len, &maxBuff1Len, rawKey, iv); 
    status = CSecFunctProvider::AES128_DecryptCBC(buff1, &buff1Len, rawKey, iv); 
    _ASSERT(memcmp(buff1, buff2, buff1Len) == 0);

    status = CSecFunctProvider::AES128_EncryptCBC(buff1, &buff1Len, &maxBuff1Len, rawKey, iv, TRUE); 
    status = CSecFunctProvider::AES128_DecryptCBC(buff1, &buff1Len, rawKey, iv, TRUE); 
    _ASSERT(memcmp(buff1, buff2, buff1Len) == 0);
/**/

}

CLightAppDlg::~CLightAppDlg() {
}	

void CLightAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLightAppDlg)
	DDX_Control(pDX, IDC_MAIN_TAB, m_mainTab);
	DDX_Text(pDX, IDC_LOGS, m_logs);
	DDX_Text(pDX, IDC_AID, m_AID);
	DDX_Text(pDX, IDC_UUIDHWT, m_UUIDHWT);
	DDX_Check(pDX, IDC_ACTIVE_HWT, m_activeHWT);
	DDX_Check(pDX, IDC_AUTH_SWA, m_authSWA);
	DDX_Text(pDX, IDC_ACTUAL_OPERATION_PENDING, m_actualOperation);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLightAppDlg, CDialog)
	//{{AFX_MSG_MAP(CLightAppDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_NOTIFY(TCN_SELCHANGE, IDC_MAIN_TAB, OnSelchangeMainTab)
	ON_BN_CLICKED(IDC_HWTOKEN_CONNECT, OnHwtokenConnect)
	ON_BN_CLICKED(IDC_HWTOKEN_DISCONNECT, OnHwtokenDisconnect)
	ON_BN_CLICKED(IDC_DEBUG_RESET, OnDebugReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLightAppDlg message handlers

BOOL CLightAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

    // SET DEFAULT INDICATOR
    SetActiveHWT(FALSE);
    SetAuthSWA(FALSE);
    m_actualOperation = STR_ACTUALOPER_NOOPER;

    //
    //  CREATE TABLE DIALOGS 
    //
	RECT rect;

	m_mainTab.InsertItem(ID_SAFEALG_TAB, STR_SAFEALG_TAB);
	m_mainTab.InsertItem(ID_MASTERLICENCE_TAB, STR_MASTERLICENCE_TAB);
	m_mainTab.InsertItem(ID_ALGLICENCE_TAB, STR_ALGLICENCE_TAB);

	m_mainTab.GetClientRect( &rect );
	m_mainTab.AdjustRect( FALSE, &rect );

	m_tabSafeAlg.Create( IDD_SAFEALG_TAB, &m_mainTab );
	m_tabSafeAlg.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabMasterLicence.Create( IDD_MASTERLICENCE_TAB, &m_mainTab );
	m_tabMasterLicence.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );

	m_tabAlgLicence.Create( IDD_ALGLICENCE_TAB, &m_mainTab );
	m_tabAlgLicence.SetWindowPos( NULL, rect.left, rect.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE );


    ShowSpecificTab(ID_SAFEALG_TAB);

    UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLightAppDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLightAppDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLightAppDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLightAppDlg::OnClose() 
{
	
	CDialog::OnClose();
}

int CLightAppDlg::Log_InsertString(CString message) {
    int             status = STAT_OK;

    UpdateData(TRUE);

    message.Insert(0, "  ");
    message.Insert(0, COleDateTime::GetCurrentTime().Format(VAR_TIMEVALUEONLY)); 
    message += "\r\n";
    
    m_logs.Insert(0, message);

    UpdateData(FALSE);
    
    return status;
}

int CLightAppDlg::Log_InsertClearLine() {
    int             status = STAT_OK;
    UpdateData(TRUE);

    m_logs.Insert(0, "\r\n"); 

    UpdateData(FALSE);
    
    return status;
}

void CLightAppDlg::SetActiveHWT(BOOL bState, CString uuidHWT) {
    CButton*    button;

    UpdateData(TRUE);

    m_activeHWT = bState;

    if ((button = (CButton*) GetDlgItem(IDC_ACTIVE_HWT))) {
        if (bState) {
            CString     message;
            if ((button = (CButton*) GetDlgItem(IDC_ACTIVE_HWT))) {
                message.Format(STR_ACTIVEHWT_CONNECTED, m_UUIDHWT);
                button->SetWindowText(message);
            }     
        }
        else button->SetWindowText(STR_ACTIVEHWT_NOCONNECTION);
    }     

    UpdateData(FALSE);
}

void CLightAppDlg::SetAuthSWA(BOOL bState, CString uuidSWA) {
    CButton*    button;

    UpdateData(TRUE);

    m_authSWA = bState;

    if ((button = (CButton*) GetDlgItem(IDC_AUTH_SWA))) {
        if (bState) {
            CString message;
            message.Format(STR_AUTHSWA_CONNECTED, uuidSWA);
            button->SetWindowText((LPCTSTR) message);
        }
        else button->SetWindowText(STR_AUTHSWA_NOCONNECTION);
    }     

    UpdateData(FALSE);
}

void CLightAppDlg::DisplayActualOperation(CString operStr) {
    UpdateData(TRUE);

    if (operStr == "") m_actualOperation = STR_ACTUALOPER_NOOPER;
    else m_actualOperation .Format(STR_ACTUALOPER_OPER, operStr);
    
    UpdateData(FALSE);
}

void CLightAppDlg::HideAllTabs() {
	m_tabSafeAlg.ShowWindow(SW_HIDE);
	m_tabMasterLicence.ShowWindow(SW_HIDE);
	m_tabAlgLicence.ShowWindow(SW_HIDE);
}

void CLightAppDlg::ShowSafeAlgTab() {
	HideAllTabs();
	m_tabSafeAlg.ShowWindow(SW_SHOWNORMAL);
}

void CLightAppDlg::ShowMasterLicenceTab() {
	HideAllTabs();
	m_tabMasterLicence.ShowWindow(SW_SHOWNORMAL);
}

void CLightAppDlg::ShowAlgLicenceTab() {
	HideAllTabs();
	m_tabAlgLicence.ShowWindow(SW_SHOWNORMAL);
}

void CLightAppDlg::ShowSpecificTab(int tabID) {
	switch (tabID) {
		case ID_SAFEALG_TAB: {
	        m_mainTab.SetCurSel(ID_SAFEALG_TAB);
			ShowSafeAlgTab();
			break;
		}
		case ID_MASTERLICENCE_TAB: {
	        m_mainTab.SetCurSel(ID_MASTERLICENCE_TAB);
			ShowMasterLicenceTab();
			break;
		}
		case ID_ALGLICENCE_TAB: {
	        m_mainTab.SetCurSel(ID_ALGLICENCE_TAB);
			ShowAlgLicenceTab();
			break;
		}
		default: {
	        m_mainTab.SetCurSel(ID_SAFEALG_TAB);
	        ShowSafeAlgTab();

			break;
		}
	}	
}


void CLightAppDlg::OnSelchangeMainTab(NMHDR* pNMHDR, LRESULT* pResult) 
{
    int sel = m_mainTab.GetCurSel();
    ShowSpecificTab(sel);
	
	*pResult = 0;
}

void CLightAppDlg::OnHwtokenConnect() 
{
    int             status = STAT_OK;
    REMOTE_APPLET   remoteApplet;
    DWORD           length = 0;
    CString         message;
    CString         timeMessage;
    SYSTEMTIME      startTime;
    SYSTEMTIME      endTime;
    float           floatTimeSpan;
    
    UpdateData(TRUE);

    // SLOT ID & ACCEPTED CARDS
    remoteApplet.slotID = SLOT_ANY_AVAILABLE;
    memcpy(remoteApplet.acceptedCards, ACCEPTED_CARDS, sizeof(ACCEPTED_CARDS)); 

    // AID
    length = AID_LEN_MAX;
    CCommonFnc::BYTE_ConvertFromHexStringToArray(m_AID, remoteApplet.appletAID, &length);
    remoteApplet.appletAIDLen = (BYTE) length;

    // UUIDHWT
    length = HWT_UUID_LENGTH;
    CCommonFnc::BYTE_ConvertFromHexStringToArray(m_UUIDHWT, remoteApplet.hwtUUID, &length);
    remoteApplet.hwtUUIDLen = (BYTE) length;
    
    memset(&startTime, 0, sizeof(SYSTEMTIME));
    memset(&endTime, 0, sizeof(SYSTEMTIME));

    pLightApp->DisplayActualOperation(STR_ACTIVEOPER_HWTCONNECTING);
    
    // CONNECT TO JAVACARD APPLET ON SELECTED CRYPTO SMARTCARD
    GetSystemTime(&startTime); 
    if ((status = m_remoteManager.Connect(&remoteApplet)) == STAT_OK) {	
        GetSystemTime(&endTime); 
        message = "Connect success";

        // SET AUTHENTIZATION INDICATOR
        pLightApp->SetActiveHWT(TRUE, m_UUIDHWT);
    }
    else {
        GetSystemTime(&endTime); 
        message.Format("Connect fail with %s (%d)", ERROR_TO_STRING(status), status);

        // SET AUTHENTIZATION INDICATOR
        pLightApp->SetActiveHWT(FALSE);
        pLightApp->SetAuthSWA(FALSE);
    }

    pLightApp->DisplayActualOperation();

    CCommonFnc::Time_GetTimeSpanSec(&startTime, &endTime, &floatTimeSpan);

    timeMessage.Format("--- elapsed timer (seconds): %f", floatTimeSpan);
    pLightApp->Log_InsertClearLine();
    pLightApp->Log_InsertString(timeMessage);
    pLightApp->Log_InsertString(message);

    UpdateData(FALSE);
}

void CLightAppDlg::OnHwtokenDisconnect() 
{
    int             status = STAT_OK;
    CString         message;
    CString         timeMessage;
    SYSTEMTIME      startTime;
    SYSTEMTIME      endTime;
    float           floatTimeSpan;

    
    memset(&startTime, 0, sizeof(SYSTEMTIME));
    memset(&endTime, 0, sizeof(SYSTEMTIME));

    pLightApp->DisplayActualOperation(STR_ACTIVEOPER_HWTDISCONNECTING);

    // DISCONNECT FROM JAVACARD APPLET ON SELECTED CRYPTO SMARTCARD
    GetSystemTime(&startTime); 
    if ((status = m_remoteManager.Disconnect()) == STAT_OK) {
        GetSystemTime(&endTime); 
        message = "Disconnect success";

        // SET AUTHENTIZATION INDICATOR
        pLightApp->SetActiveHWT(FALSE);
        pLightApp->SetAuthSWA(FALSE);
    }
    else {
        GetSystemTime(&endTime); 
        message.Format("Disconnect fail with %s (%d)", ERROR_TO_STRING(status), status);
    }

    pLightApp->DisplayActualOperation();

    CCommonFnc::Time_GetTimeSpanSec(&startTime, &endTime, &floatTimeSpan);

    timeMessage.Format("--- elapsed timer (seconds): %f", floatTimeSpan);
    pLightApp->Log_InsertClearLine();
    pLightApp->Log_InsertString(timeMessage);
    pLightApp->Log_InsertString(message);
}

void CLightAppDlg::OnDebugReset() 
{
    int             status = STAT_OK;

    CString         message;
    CString         timeMessage;
    SYSTEMTIME      startTime;
    SYSTEMTIME      endTime;
    float           floatTimeSpan;

    if (MessageBox(STR_DEBUGRESET_PROCESS, STR_APP_NAME, MB_YESNO) == IDYES) {
        memset(&startTime, 0, sizeof(SYSTEMTIME));
        memset(&endTime, 0, sizeof(SYSTEMTIME));

        pLightApp->DisplayActualOperation(STR_ACTIVEOPER_DEBUGRESET);

        // RESET INTERNAL STRUCTS 
        GetSystemTime(&startTime); 
        if ((status = m_remoteManager.DebugReset()) == STAT_OK) {
            GetSystemTime(&endTime); 
            message = "Debug reset success";

            // SET AUTHENTIZATION INDICATOR
            pLightApp->SetAuthSWA(FALSE);
        }
        else {
            GetSystemTime(&endTime); 
            message.Format("Debug reset fail with %s (%d)", ERROR_TO_STRING(status), status);
        }

        pLightApp->DisplayActualOperation();

        CCommonFnc::Time_GetTimeSpanSec(&startTime, &endTime, &floatTimeSpan);

        timeMessage.Format("--- elapsed timer (seconds): %f", floatTimeSpan);
        pLightApp->Log_InsertClearLine();
        pLightApp->Log_InsertString(timeMessage);
        pLightApp->Log_InsertString(message);
    }
}
