// LightAppDlg.h : header file
//

#if !defined(AFX_LIGHTAPPDLG_H__9FC76FBE_CCAA_4D1E_B754_C4B815ED0D1C__INCLUDED_)
#define AFX_LIGHTAPPDLG_H__9FC76FBE_CCAA_4D1E_B754_C4B815ED0D1C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "TabMasterLicence.h"
#include "TabAlgLicence.h"
#include "TabSafeAlg.h"

#include "stdafx.h"
#include "..\SecureFW\RemoteAlgManager.h"

/////////////////////////////////////////////////////////////////////////////
// CLightAppDlg dialog

class CLightAppDlg : public CDialog
{
// Construction
public:
	CLightAppDlg(CWnd* pParent = NULL);	// standard constructor
	~CLightAppDlg();	

// Dialog Data
	//{{AFX_DATA(CLightAppDlg)
	enum { IDD = IDD_LIGHTAPP_DIALOG };
	CTabCtrl	    m_mainTab;
	CString	        m_logs;
	CString	        m_AID;
	CString	        m_UUIDHWT;
	BOOL	        m_activeHWT;
	BOOL	        m_authSWA;
	CString	        m_actualOperation;
	//}}AFX_DATA

    CRemoteAlgManager  m_remoteManager;
	
    // ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLightAppDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

public:
    // DISPLAY LOG MESSAGE IN LOGGING AREA
    int Log_InsertString(CString message);
    int Log_InsertClearLine();

    // ACTUALIZE ACTIVE HARDWARE TOKEN INDICATOR
    void SetActiveHWT(BOOL bState, CString uuidHWT = "");
    // ACTUALIZE SOFTWARE AGENT AUTHENTIZATION INDICATOR
    void SetAuthSWA(BOOL bState, CString uuidSWA = "");

    // DISPLAY ACTUAL PENDING OPERATION
    void DisplayActualOperation(CString operStr = "");

// Implementation
protected:
	HICON               m_hIcon;

    CTabSafeAlg         m_tabSafeAlg;
    CTabMasterLicence   m_tabMasterLicence;
    CTabAlgLicence      m_tabAlgLicence;

protected:
    void HideAllTabs();
    void ShowSafeAlgTab();
    void ShowMasterLicenceTab();
    void ShowAlgLicenceTab();
    void ShowSpecificTab(int tabID);

	// Generated message map functions
	//{{AFX_MSG(CLightAppDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	afx_msg void OnSelchangeMainTab(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnHwtokenConnect();
	afx_msg void OnHwtokenDisconnect();
	afx_msg void OnDebugReset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LIGHTAPPDLG_H__9FC76FBE_CCAA_4D1E_B754_C4B815ED0D1C__INCLUDED_)
