#ifndef STATUS_H
#define STATUS_H

#define STAT_OK                                 0
#define STAT_NOT_IMPLEMENTED_YET                1
#define STAT_SESSION_NOT_OPEN                   2
#define STAT_NOT_ENOUGHT_MEMORY                 3
#define STAT_CHANNEL_SECURITY_NOT_ACHIEVED      4
#define STAT_CHANNEL_DESTROY_FAIL               5
#define STAT_CHANNEL_NOT_EXISTS                 6 
#define STAT_INCORRECT_HWT                      7
#define STAT_PAR_FAIL                           8

    // ISO7816 ERRORS
#define SW_FILE_FULL                        0x6A84
#define SW_UNKNOWN  				        0x6F00
#define SW_CLA_NOT_SUPPORTED 		        0x6E00
#define SW_INS_NOT_SUPPORTED 		        0x6D00
#define SW_CORRECT_LENGTH_00 		        0x6C00
#define SW_WRONG_P1P2   			        0x6B00
#define SW_INCORRECT_P1P2			        0x6A86
#define SW_RECORD_NOT_FOUND 		        0x6A83	
#define SW_FILE_NOT_FOUND 			        0x6A82
#define SW_FUNC_NOT_SUPPORTED		        0x6A81
#define SW_WRONG_DATA   			        0x6A80
#define SW_APPLET_SELECT_FAILED 	        0x6999
#define SW_COMMAND_NOT_ALLOWED 		        0x6986
#define SW_CONDITIONS_NOT_SATISFIED         0x6985
#define SW_DATA_INVALID 			        0x6984
#define SW_FILE_INVALID 			        0x6983
#define SW_SECURITY_STATUS_NOT_SATISFIED    0x6982
#define SW_WRONG_LENGTH         			0x6700
#define SW_BYTES_REMAINING_00       		0x6100
#define SW_NO_ERROR             			0x9000	
     
    // MY OWN APPLET ERRORS
#define SW_PIN_BLOCKED			            0x6680
#define SW_USAGE_UPDATE_FAIL	            0x6681
#define SW_USAGE_NOT_ALLOWED	            0x6682

const char* ErrorToString(int error);

#define ERROR_TO_STRING(x) ErrorToString(x)

#endif